from typing import Awaitable, Callable, List, Union


class Ui:

    from .elements.button import Button as button
    from .elements.checkbox import Checkbox as checkbox
    from .elements.custom_example import CustomExample as custom_example
    from .elements.icon import Icon as icon
    from .elements.input import Input as input
    from .elements.joystick import Joystick as joystick
    from .elements.label import Label as label
    from .elements.html import Html as html
    from .elements.markdown import Markdown as markdown
    from .elements.link import Link as link
    from .elements.number import Number as number
    from .elements.radio import Radio as radio
    from .elements.select import Select as select
    from .elements.slider import Slider as slider
    from .elements.switch import Switch as switch
    from .elements.toggle import Toggle as toggle

    from .elements.plot import Plot as plot
    from .elements.line_plot import LinePlot as line_plot

    from .elements.row import Row as row
    from .elements.column import Column as column
    from .elements.card import Card as card

    from .timer import Timer as timer

    startup_tasks: List[Union[Callable, Awaitable]] = []

    def on_startup(self, task: Union[Callable, Awaitable]):

        self.startup_tasks.append(task)

    shutdown_tasks: List[Union[Callable, Awaitable]] = []

    def on_shutdown(self, task: Union[Callable, Awaitable]):

        self.shutdown_tasks.append(task)
